note
	description: "A linear container represented by an array."
	author: "Jackie Wang"
	date: "$Date$"
	revision: "$Revision$"

class
	LINEAR_CONTAINER

create
	make_from

feature -- attributes

	rep: ARRAY[STRING]

feature -- commands

	make_from (new_rep: like rep)
		require
			lower_index: new_rep.lower = 1
		do
			rep := new_rep
		end

feature -- recursive queries version 1

	content_1: LINKED_LIST[STRING]
			-- Convert `rep` to a linked list
		do
			create Result.make
			Result.compare_objects
			content_helper_1 (Result, 1)
		end

	content_helper_1 (list: LINKED_LIST[STRING]; i: INTEGER)
		do
			if i <= rep.count then
				list.extend (rep[i])
				content_helper_1 (list, i + 1)
			end
		end

feature -- recursive queries version 2

	content_2: LINKED_LIST[STRING]
		do
			Result := content_helper_2 (1)
		end

	content_helper_2 (i: INTEGER): LINKED_LIST[STRING]
		local
			sublist: LINKED_LIST[STRING]
		do
			create Result.make
			Result.compare_objects
			if i <= rep.count then
				Result.extend (rep[i])
				sublist := content_helper_2 (i + 1)
				across
					sublist is l_s
				loop
					Result.extend (l_s)
				end
			end
		end

end
